## nss 3.59

=== nss/lib/freebl/Makefile ===
#! gmake
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

#######################################################################
# (1) Include initial platform-independent assignments (MANDATORY).   #
#######################################################################

include manifest.mn

#######################################################################
# (2) Include "global" configuration information. (OPTIONAL)          #
#######################################################################

include $(CORE_DEPTH)/coreconf/config.mk

#######################################################################
# (3) Include "component" configuration information. (OPTIONAL)       #
#######################################################################



#######################################################################
# (4) Include "local" platform-dependent assignments (OPTIONAL).      #
#######################################################################

include config.mk

# default for all platforms
# unset this on those that have multiple freebl libraries
FREEBL_BUILD_SINGLE_SHLIB = 1

ifdef USE_64
	DEFINES += -DNSS_USE_64
endif

ifdef USE_ABI32_FPU
	DEFINES += -DNSS_USE_ABI32_FPU
endif

ifeq ($(FREEBL_NO_DEPEND),1)
	DEFINES += -DFREEBL_NO_DEPEND
	STUBS_SRCS = stubs.c
endif

ifeq ($(FREEBL_LOWHASH),1)
	DEFINES += -DFREEBL_LOWHASH
	LOWHASH_SRCS = nsslowhash.c
	LOWHASH_EXPORTS = nsslowhash.h
	MAPFILE_SOURCE = freebl_hash_vector.def
	NEED_STUB_BUILD = 1
else
	MAPFILE_SOURCE = freebl.def
endif

ifdef USE_STUB_BUILD
	CSRCS           = lowhash_vector.c
	SIMPLE_OBJS     = $(CSRCS:.c=$(OBJ_SUFFIX))
	OBJS            = $(addprefix $(OBJDIR)/$(PROG_PREFIX), $(SIMPLE_OBJS))
	ALL_TRASH :=    $(TARGETS) $(OBJS) $(OBJDIR) LOGS TAGS $(GARBAGE) \
                $(NOSUCHFILE) so_locations
	MAPFILE_SOURCE = freebl_hash.def
endif

# FREEBL_USE_PRELINK
#
# Most modern version of Linux support a speed optimization scheme where an
# application called prelink modifies programs and shared libraries to quickly
# load if they fit into an already designed address space. In short, prelink
# scans the list of programs and libraries on your system, assigns them a
# predefined space in the the address space, then provides the fixups to the
# library.
#
# The modification of the shared library is correctly detected by the freebl
# FIPS checksum scheme where we check a signed hash of the library against the
# library itself.
#
# The prelink command itself can reverse the process of modification and output
# the prestine shared library as it was before prelink made it's changes.
# This option tells Freebl could use prelink to output the original copy of
# the shared library before prelink modified it.
#
# FREEBL_PRELINK_COMMAND
#
# This is an optional environment variable which can override the default
# prelink command. It could be used on systems that did something similiar to
# prelink but used a different command and syntax. The only requirement is the
# program must take the library as the last argument, the program must output
# the original library to standard out, and the program does not need to take
# any quoted or imbedded spaces in its arguments (except the path to the
# library itself, which can have imbedded spaces or special characters).
#
ifdef FREEBL_USE_PRELINK
	DEFINES += -DFREEBL_USE_PRELINK
ifdef LINUX
	DEFINES += -D__GNU_SOURCE=1
endif
endif
ifdef NSS_NO_INIT_SUPPORT
    DEFINES += -DNSS_NO_INIT_SUPPORT
endif

ifdef FREEBL_PRELINK_COMMAND
	DEFINES +=-DFREEBL_PRELINK_COMMAND=\"$(FREEBL_PRELINK_COMMAND)\"
endif
# NSS_X86 means the target is a 32-bits x86 CPU architecture
# NSS_X64 means the target is a 64-bits 64 CPU architecture
# NSS_X86_OR_X64 means the target is either x86 or x64
ifeq (,$(filter-out i386 x386 x86 x86_64,$(CPU_ARCH)))
        DEFINES += -DNSS_X86_OR_X64
        EXTRA_SRCS += gcm-x86.c aes-x86.c
$(OBJDIR)/gcm-x86.o: CFLAGS += -mpclmul -maes
$(OBJDIR)/aes-x86.o: CFLAGS += -mpclmul -maes
ifneq (,$(USE_64)$(USE_X32))
        DEFINES += -DNSS_X64
else
        DEFINES += -DNSS_X86
endif
endif
ifeq ($(CPU_ARCH),aarch64)
    ifdef CC_IS_CLANG
        DEFINES += -DUSE_HW_AES -DUSE_HW_SHA1 -DUSE_HW_SHA2
        EXTRA_SRCS += aes-armv8.c gcm-aarch64.c sha1-armv8.c sha256-armv8.c
    else ifeq (1,$(CC_IS_GCC))
        # GCC versions older than 4.9 don't support ARM AES. The check
        # is done in two parts, first allows "major.minor" == "4.9",
        # and then rejects any major versions prior to 5. Note that
        # there has been no GCC 4.10, as it was renamed to GCC 5.
        ifneq (,$(filter 4.9,$(word 1,$(GCC_VERSION)).$(word 2,$(GCC_VERSION))))
            DEFINES += -DUSE_HW_AES -DUSE_HW_SHA1 -DUSE_HW_SHA2
            EXTRA_SRCS += aes-armv8.c gcm-aarch64.c sha1-armv8.c sha256-armv8.c
        endif
        ifeq (,$(filter 0 1 2 3 4,$(word 1,$(GCC_VERSION))))
            DEFINES += -DUSE_HW_AES -DUSE_HW_SHA1 -DUSE_HW_SHA2
            EXTRA_SRCS += aes-armv8.c gcm-aarch64.c sha1-armv8.c sha256-armv8.c
        endif
    endif
endif
ifeq ($(CPU_ARCH),arm)
ifndef NSS_DISABLE_ARM32_NEON
    EXTRA_SRCS += gcm-arm32-neon.c
endif
    ifdef CC_IS_CLANG
        DEFINES += -DUSE_HW_AES -DUSE_HW_SHA1 -DUSE_HW_SHA2
        EXTRA_SRCS += aes-armv8.c sha1-armv8.c sha256-armv8.c
    else ifeq (1,$(CC_IS_GCC))
        # GCC versions older than 4.9 don't support ARM AES. The check
        # is done in two parts, first allows "major.minor" == "4.9",
        # and then rejects any major versions prior to 5. Note that
        # there has been no GCC 4.10, as it was renamed to GCC 5.
        ifneq (,$(filter 4.9,$(word 1,$(GCC_VERSION)).$(word 2,$(GCC_VERSION))))
            DEFINES += -DUSE_HW_AES -DUSE_HW_SHA1 -DUSE_HW_SHA2
            EXTRA_SRCS += aes-armv8.c sha1-armv8.c sha256-armv8.c
        endif
        ifeq (,$(filter 0 1 2 3 4,$(word 1,$(GCC_VERSION))))
            DEFINES += -DUSE_HW_AES -DUSE_HW_SHA1 -DUSE_HW_SHA2
            EXTRA_SRCS += aes-armv8.c sha1-armv8.c sha256-armv8.c
        endif
    endif
endif

ifeq ($(OS_TARGET),OSF1)
    DEFINES += -DMP_ASSEMBLY_MULTIPLY -DMP_NO_MP_WORD
    MPI_SRCS += mpvalpha.c
endif

ifeq (OS2,$(OS_TARGET))
    ASFILES  = mpi_x86_os2.s
    DEFINES += -DMP_ASSEMBLY_MULTIPLY -DMP_ASSEMBLY_SQUARE
    DEFINES += -DMP_ASSEMBLY_DIV_2DX1D
    DEFINES += -DMP_USE_UINT_DIGIT -DMP_NO_MP_WORD
    DEFINES += -DMP_IS_LITTLE_ENDIAN
endif

ifeq (,$(filter-out WINNT WIN95,$(OS_TARGET)))
ifndef USE_64
# 32-bit Windows
ifdef NS_USE_GCC
# Ideally, we want to use assembler
#     ASFILES  = mpi_x86.s
#     DEFINES += -DMP_ASSEMBLY_MULTIPLY -DMP_ASSEMBLY_SQUARE \
#                -DMP_ASSEMBLY_DIV_2DX1D
# but we haven't figured out how to make it work, so we are not
# using assembler right now.
    ASFILES  =
    DEFINES += -DMP_NO_MP_WORD -DMP_USE_UINT_DIGIT
else
# MSVC
    MPI_SRCS += mpi_x86_asm.c
    DEFINES += -DMP_ASSEMBLY_MULTIPLY -DMP_ASSEMBLY_SQUARE
    DEFINES += -DMP_ASSEMBLY_DIV_2DX1D -DMP_USE_UINT_DIGIT -DMP_NO_MP_WORD
    ifdef BUILD_OPT
	OPTIMIZER += -Ox  # maximum optimization for freebl
    endif
    # The Intel AES assembly code requires Visual C++ 2010.
    # if $(_MSC_VER) >= 1600 (Visual C++ 2010)
    ifeq ($(firstword $(sort $(_MSC_VER) 1600)),1600)
	DEFINES += -DUSE_HW_AES -DINTEL_GCM
	ASFILES += intel-aes-x86-masm.asm intel-gcm-x86-masm.asm
	EXTRA_SRCS += intel-gcm-wrap.c
	ifeq ($(CLANG_CL),1)
	    INTEL_GCM_CLANG_CL = 1
	endif
    endif
endif
else
    # -DMP_NO_MP_WORD
    DEFINES += -DMP_IS_LITTLE_ENDIAN
ifdef NS_USE_GCC
# Ideally, we should use amd64 assembly code, but it's not yet mingw-w64
# compatible.
else
# MSVC
    ifdef BUILD_OPT
	OPTIMIZER += -Ox  # maximum optimization for freebl
    endif
ifeq ($(CPU_ARCH),x86_64)
    ASFILES  = arcfour-amd64-masm.asm mpi_amd64_masm.asm mp_comba_amd64_masm.asm
    DEFINES += -DNSS_BEVAND_ARCFOUR -DMPI_AMD64 -DMP_ASSEMBLY_MULTIPLY
    DEFINES += -DNSS_USE_COMBA
    # The Intel AES assembly code requires Visual C++ 2010 (10.0). The _xgetbv
    # compiler intrinsic function requires Visual C++ 2010 (10.0) SP1.
    ifeq ($(_MSC_VER_GE_10SP1),1)
	DEFINES += -DUSE_HW_AES -DINTEL_GCM
	ASFILES += intel-aes-x64-masm.asm intel-gcm-x64-masm.asm
	EXTRA_SRCS += intel-gcm-wrap.c
	ifeq ($(CLANG_CL),1)
	    INTEL_GCM_CLANG_CL = 1
	endif
    endif
    MPI_SRCS += mpi_amd64.c
endif
endif
endif
endif

ifeq ($(OS_TARGET),IRIX)
ifeq ($(USE_N32),1)
    ASFILES  = mpi_mips.s
    ifeq ($(NS_USE_GCC),1)
	ASFLAGS = -Wp,-P -Wp,-traditional -O -mips3
    else
	ASFLAGS = -O -OPT:Olimit=4000 -dollar -fullwarn -xansi -n32 -mips3
    endif
    DEFINES += -DMP_ASSEMBLY_MULTIPLY -DMP_ASSEMBLY_SQUARE
    DEFINES += -DMP_USE_UINT_DIGIT
endif
endif

ifeq ($(OS_TARGET),Darwin)
ifeq ($(CPU_ARCH),x86_64)
    ASFILES  = mpi_amd64_common.s
    DEFINES += -DMPI_AMD64 -DMP_IS_LITTLE_ENDIAN
    DEFINES += -DMP_ASSEMBLY_MULTIPLY -DNSS_USE_COMBA
    MPI_SRCS += mpi_amd64.c mp_comba.c
else ifeq ($(CPU_ARCH),x86)
    ASFILES  = mpi_sse2.s
    DEFINES += -DMP_USE_UINT_DIGIT
    DEFINES += -DMP_ASSEMBLY_MULTIPLY -DMP_ASSEMBLY_SQUARE
    DEFINES += -DMP_ASSEMBLY_DIV_2DX1D
endif
endif # Darwin

ifeq ($(OS_TARGET),Linux)
ifeq ($(CPU_ARCH),x86_64)
    # Lower case s on mpi_amd64_common due to make implicit rules.
    ASFILES  = arcfour-amd64-gas.s mpi_amd64_common.s
    ASFLAGS += -fPIC -Wa,--noexecstack
    DEFINES += -DNSS_BEVAND_ARCFOUR -DMPI_AMD64 -DMP_ASSEMBLY_MULTIPLY
    DEFINES += -DNSS_USE_COMBA
    DEFINES += -DMP_IS_LITTLE_ENDIAN
#   DEFINES += -DMPI_AMD64_ADD
    # comment the next four lines to turn off Intel HW acceleration.
    DEFINES += -DUSE_HW_AES -DINTEL_GCM
    ASFILES += intel-aes.s intel-gcm.s
    EXTRA_SRCS += intel-gcm-wrap.c
    INTEL_GCM = 1
    MPI_SRCS += mpi_amd64.c mp_comba.c
endif
ifeq ($(CPU_ARCH),x86)
    ASFILES  = mpi_x86.s
    DEFINES += -DMP_ASSEMBLY_MULTIPLY -DMP_ASSEMBLY_SQUARE
    DEFINES += -DMP_ASSEMBLY_DIV_2DX1D -DMP_USE_UINT_DIGIT
    DEFINES += -DMP_IS_LITTLE_ENDIAN
endif
ifeq ($(CPU_ARCH),arm)
    DEFINES += -DMP_ASSEMBLY_MULTIPLY -DMP_ASSEMBLY_SQUARE
    DEFINES += -DMP_USE_UINT_DIGIT
    DEFINES += -DSHA_NO_LONG_LONG # avoid 64-bit arithmetic in SHA512
    MPI_SRCS += mpi_arm.c
endif
ifeq ($(CPU_ARCH),ppc)
    EXTRA_SRCS += gcm-ppc.c
    ASFILES += sha512-p8.s
ifdef USE_64
    DEFINES += -DNSS_NO_INIT_SUPPORT
endif # USE_64
endif # ppc
endif # Linux

ifeq ($(OS_TARGET),AIX)
    DEFINES += -DMP_USE_UINT_DIGIT
    ifndef USE_64
	DEFINES += -DMP_NO_DIV_WORD -DMP_NO_ADD_WORD -DMP_NO_SUB_WORD
    endif
endif # AIX

ifeq ($(OS_TARGET), HP-UX)
ifneq ($(OS_TEST), ia64)
# PA-RISC
ASFILES += ret_cr16.s
ifndef USE_64
    FREEBL_BUILD_SINGLE_SHLIB =
    HAVE_ABI32_INT32 = 1
    HAVE_ABI32_FPU = 1
endif
ifdef FREEBL_CHILD_BUILD
ifdef USE_ABI32_INT32
# build for DA1.1 (HP PA 1.1) 32-bit ABI build with 32-bit arithmetic
    DEFINES  += -DMP_USE_UINT_DIGIT -DMP_NO_MP_WORD
    DEFINES += -DSHA_NO_LONG_LONG # avoid 64-bit arithmetic in SHA512
else
ifdef USE_64
# this builds for DA2.0W (HP PA 2.0 Wide), the LP64 ABI, using 64-bit digits
    MPI_SRCS += mpi_hp.c
    ASFILES  += hpma512.s hppa20.s
    DEFINES  += -DMP_ASSEMBLY_MULTIPLY -DMP_ASSEMBLY_SQUARE
else
# this builds for DA2.0 (HP PA 2.0 Narrow) ABI32_FPU model
# (the 32-bit ABI with 64-bit registers) using 64-bit digits
    MPI_SRCS += mpi_hp.c
    ASFILES  += hpma512.s hppa20.s
    DEFINES  += -DMP_ASSEMBLY_MULTIPLY -DMP_ASSEMBLY_SQUARE
ifndef NS_USE_GCC
    ARCHFLAG = -Aa +e +DA2.0 +DS2.0
endif
endif
endif
endif
endif
endif

# The blapi functions are defined not only in the freebl shared
# libraries but also in the shared libraries linked with loader.c
# (libsoftokn3.so and libssl3.so).  We need to use GNU ld's
# -Bsymbolic option or the equivalent option for other linkers
# to bind the blapi function references in FREEBLVector vector

=== debian/changelog ===
nss (2:3.59-1) unstable; urgency=medium

  * New upstream release. Fixes: #972713.
  * debian/libnss3.symbols: Add NSS_3.59/NSSUTIL_3.59 symbol version.

 -- Mike Hommey <glandium@debian.org>  Wed, 18 Nov 2020 07:26:57 +0900

## nss 3.60

=== debian/changelog ===
nss (2:3.60-1~mx19+1) mx; urgency=medium

  * Initial packaging of upstream release for MX 19.

 -- SwampRabbit <swamprabbit@mxlinux.org>  Tue, 12 Jan 2021 12:40:27 -0500

nss (2:3.60-1) unstable; urgency=medium

  * New upstream release. Fixes: #977723.

 -- Mike Hommey <glandium@debian.org>  Sun, 20 Dec 2020 06:36:28 +0900

=== debian/control ===
Source: nss
Section: libs
Priority: optional
Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
XSBC-Original-Maintainer: Maintainers of Mozilla-related packages <team+pkg-mozilla@tracker.debian.org>
Uploaders: Mike Hommey <glandium@debian.org>
Build-Depends: debhelper (>= 9.20160403),
 dpkg-dev (>= 1.17.14),
 libnspr4-dev (>= 2:4.24),
 zlib1g-dev,
 libsqlite3-dev (>= 3.3.9),
 libnss3-tools:native (>= 2:3.19-1-1~) <cross>
Standards-Version: 4.1.4
Homepage: http://www.mozilla.org/projects/security/pki/nss/
Vcs-Git: https://salsa.debian.org/mozilla-team/nss.git
Vcs-Browser: https://salsa.debian.org/mozilla-team/nss

Package: libnss3
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
 ${misc:Depends}
Conflicts: libnss3-1d (<< 2:3.13.4-2)
Multi-Arch: ${misc:Multi-Arch}
Description: Network Security Service libraries
 This is a set of libraries designed to support cross-platform development
 of security-enabled client and server applications. It can support SSLv2
 and  v4, TLS, PKCS #5, #7, #11, #12, S/MIME, X.509 v3 certificates and
 other security standards.

Package: libnss3-tools
Section: admin
Architecture: any
Depends: ${shlibs:Depends},
 ${misc:Depends}
Description: Network Security Service tools
 This is a set of tools on top of the Network Security Service libraries.
 This package includes:
  * certutil: manages certificate and key databases (cert7.db and key3.db)
  * modutil: manages the database of PKCS11 modules (secmod.db)
  * pk12util: imports/exports keys and certificates between the cert/key
    databases and files in PKCS12 format.
  * shlibsign: creates .chk files for use in FIPS mode.
  * signtool: creates digitally-signed jar archives containing files and/or
    code.
  * ssltap: proxy requests for an SSL server and display the contents of
    the messages exchanged between the client and server.
Homepage: http://www.mozilla.org/projects/security/pki/nss/tools/

Package: libnss3-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends},
 libnss3 (= ${binary:Version}),
 libnspr4-dev (>= 4.6.6-1)
Multi-Arch: ${misc:Multi-Arch}
Description: Development files for the Network Security Service libraries
 This is a set of libraries designed to support cross-platform development
 of security-enabled client and server applications. It can support SSLv2
 and  v4, TLS, PKCS #5, #7, #11, #12, S/MIME, X.509 v3 certificates and
 other security standards.
 .
 Install this package if you wish to develop your own programs using the
 Network Security Service Libraries.

=== debian/rules ===
#!/usr/bin/make -f
include debian/make.mk

$(call lazy,DEB_BUILD_ARCH,$$(shell dpkg-architecture -qDEB_BUILD_ARCH))
$(call lazy,DEB_BUILD_GNU_TYPE,$$(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE))
$(call lazy,DEB_HOST_ARCH,$$(shell dpkg-architecture -qDEB_HOST_ARCH))
$(call lazy,DEB_HOST_ARCH_OS,$$(shell dpkg-architecture -qDEB_HOST_ARCH_OS))
$(call lazy,DEB_HOST_GNU_TYPE,$$(shell dpkg-architecture -qDEB_HOST_GNU_TYPE))
$(call lazy,DEB_HOST_GNU_CPU,$$(shell dpkg-architecture -qDEB_HOST_GNU_CPU))
$(call lazy,DEB_HOST_MULTIARCH,$$(shell dpkg-architecture -qDEB_HOST_MULTIARCH))
$(call lazy,CFLAGS,$$(shell dpkg-buildflags --get CFLAGS))
$(call lazy,CPPFLAGS,$$(shell dpkg-buildflags --get CPPFLAGS))
$(call lazy,LDFLAGS,$$(shell dpkg-buildflags --get LDFLAGS))

PREPROCESS_FILES := $(wildcard debian/*.in)

$(PREPROCESS_FILES:.in=): %: %.in
	sed 's,/@DEB_HOST_MULTIARCH@,$(DEB_HOST_MULTIARCH:%=/%),g;$(EXTRA_REPLACES)' $< > $@

UPSTREAM_VERSION := $(shell dpkg-parsechangelog | sed -n 's/^Version: *\([0-9]*:\)\?\([0-9.]*+really\)\?\([^~]*\)\(~.*\)\?-.*$$/\3/ p')
MOD_MAJOR_VERSION := $(word 1, $(subst ., ,$(UPSTREAM_VERSION)))
MOD_MINOR_VERSION := $(word 2, $(subst ., ,$(UPSTREAM_VERSION)))
MOD_PATCH_VERSION := $(or $(word 3, $(subst ., ,$(UPSTREAM_VERSION))),0)

debian/nss.pc: EXTRA_REPLACES := s/@VERSION@/$(UPSTREAM_VERSION)/
debian/nss-config: EXTRA_REPLACES := s/@MOD_MAJOR_VERSION@/$(MOD_MAJOR_VERSION)/;s/@MOD_MINOR_VERSION@/$(MOD_MINOR_VERSION)/;s/@MOD_PATCH_VERSION@/$(MOD_PATCH_VERSION)/
debian/libnss3.lintian-overrides: EXTRA_REPLACES := s,/@DEB_HOST_MULTIARCH_WC@,$(DEB_HOST_MULTIARCH:%=/*),g

TOOLCHAIN :=

ifneq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
ifeq ($(origin CC),default)
TOOLCHAIN += CC=$(DEB_HOST_GNU_TYPE)-gcc
endif
ifeq ($(origin CXX),default)
CXX := $(DEB_HOST_GNU_TYPE)-g++
TOOLCHAIN += CXX=$(CXX)
endif
TOOLCHAIN += CCC=$(CXX)
ifeq ($(origin RANLIB),default)
TOOLCHAIN += RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib
endif
TOOLCHAIN += OS_TEST=$(DEB_HOST_GNU_CPU)
TOOLCHAIN += KERNEL=$(DEB_HOST_ARCH_OS)
endif

# $(foreach foo,$(list),$(call cmd,some command $(foo))) expands to
#    some command first-elem
#    some command second-elem
#    etc.
# This avoid using a long one liner with semi colons.
define cmd
$(1)

endef

CFLAGS += -Wall -pipe

DISTDIR := $(CURDIR)/dist

COMMON_MAKE_FLAGS := \
	SOURCE_PREFIX=$(DISTDIR) \
	SOURCE_MD_DIR=$(DISTDIR) \
	DIST=$(DISTDIR) \
	OBJDIR_NAME=OBJS \
	$(and $(filter 64,$(shell dpkg-architecture -qDEB_HOST_ARCH_BITS)),USE_64=1) \
	$(and $(filter x32,$(shell dpkg-architecture -qDEB_HOST_ARCH)),USE_X32=1) \
	$(NULL)

NSS_TOOLS := \
	certutil \
	chktest \
	cmsutil \
	crlutil \
	derdump \
	httpserv \
	modutil \
	ocspclnt \
	p7content \
	p7env \
	p7sign \
	p7verify \
	pk12util \
	pk1sign \
	pwdecrypt \
	rsaperf \
	selfserv \
	shlibsign \
	signtool \
	signver \
	ssltap \
	strsclnt \
	symkeyutil \
	tstclnt \
	vfychain \
	vfyserv \
	$(NULL)

override_dh_auto_build:
	$(MAKE) -C nss/coreconf/nsinstall \
		$(COMMON_MAKE_FLAGS) \
		CC=$(DEB_BUILD_GNU_TYPE)-gcc \
		ARCHFLAG=

	$(MAKE) -C nss \
		all \
		$(COMMON_MAKE_FLAGS) \
		MOZILLA_CLIENT=1 \
		NSPR_INCLUDE_DIR=/usr/include/nspr \
		NSPR_LIB_DIR=/usr/lib/$(DEB_HOST_MULTIARCH) \
		BUILD_OPT=1 \
		NS_USE_GCC=1 \
		OPTIMIZER="$(CFLAGS) $(CPPFLAGS)" \
		LDFLAGS='$(LDFLAGS) $$(ARCHFLAG) $$(ZDEFS_FLAG)' \
		DSO_LDOPTS='-shared $$(LDFLAGS)' \
		NSS_USE_SYSTEM_SQLITE=1 \
		NSS_ENABLE_ECC=1 \
		CHECKLOC= \
		$(TOOLCHAIN)

override_dh_auto_clean:
	-$(MAKE) -C nss \
		clobber \
		$(COMMON_MAKE_FLAGS) \
		BUILD_OPT=1

	rm -rf $(DISTDIR) $(PREPROCESS_FILES:.in=)

manpage = $(addsuffix .1,$(addprefix nss/doc/nroff/,$(1)))

override_dh_auto_install: $(PREPROCESS_FILES:.in=)
	install -m 755 -d debian/libnss3/usr/lib/$(DEB_HOST_MULTIARCH)/nss debian/libnss3-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig
	install -m 644 -t debian/libnss3/usr/lib/$(DEB_HOST_MULTIARCH) \
		$(DISTDIR)/lib/libnss3.so \
		$(DISTDIR)/lib/libnssutil3.so \
		$(DISTDIR)/lib/libsmime3.so \
		$(DISTDIR)/lib/libssl3.so
	install -m 644 -t debian/libnss3/usr/lib/$(DEB_HOST_MULTIARCH)/nss \
		$(DISTDIR)/lib/libfreebl3.so \
		$(DISTDIR)/lib/libfreeblpriv3.so \
		$(DISTDIR)/lib/libsoftokn3.so \
		$(DISTDIR)/lib/libnssdbm3.so \
		$(DISTDIR)/lib/libnssckbi.so

	install -m 644 -t debian/libnss3-dev/usr/include/nss \
		$(DISTDIR)/public/nss/*
	install -m 644 -t debian/libnss3-dev/usr/lib/$(DEB_HOST_MULTIARCH) \
		$(DISTDIR)/lib/libcrmf.a
	install -m 644 -t debian/libnss3-dev/usr/lib/$(DEB_HOST_MULTIARCH)/pkgconfig debian/nss.pc
	install -m 755 -t debian/libnss3-dev/usr/bin debian/nss-config

	install -m 755 -t debian/libnss3-tools/usr/bin $(addprefix $(DISTDIR)/bin/,$(NSS_TOOLS))
	install -m 755 -d $(DISTDIR)/man
	install -m 644 -t $(DISTDIR)/man $(wildcard $(call manpage,$(NSS_TOOLS)))

	# these utilities are too generically-named, so we prefix them with nss- (see http://bugs.debian.org/701141)
	$(foreach bin, \
		addbuiltin \
		dbtest \
		pp \
		, \
		$(call cmd,install -m 755 -T $(DISTDIR)/bin/$(bin) debian/libnss3-tools/usr/bin/nss-$(bin)) \
		$(if $(wildcard $(call manpage,$(bin))),$(call cmd,install -m 644 -T $(call manpage,$(bin)) $(DISTDIR)/man/nss-$(bin).1)))

ifeq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
SHLIBSIGN = LD_LIBRARY_PATH=debian/libnss3/usr/lib/$(DEB_HOST_MULTIARCH) debian/libnss3-tools/usr/bin/shlibsign
else
SHLIBSIGN = shlibsign
endif

override_dh_strip:
	dh_strip --no-automatic-dbgsym
#	dh_strip --dbgsym-migration='libnss3-dbg (<< 2:3.37-1~)'
	$(foreach lib,libsoftokn3.so libfreebl3.so libfreeblpriv3.so libnssdbm3.so, \
		$(call cmd,umask 022; $(SHLIBSIGN) -v -i debian/libnss3/usr/lib/$(DEB_HOST_MULTIARCH)/nss/$(lib)))

ifeq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
	# Check FIPS mode correctly works
	mkdir debian/tmp
	LD_LIBRARY_PATH=debian/libnss3/usr/lib/$(DEB_HOST_MULTIARCH):debian/libnss3/usr/lib/$(DEB_HOST_MULTIARCH)/nss debian/libnss3-tools/usr/bin/modutil -create -dbdir debian/tmp < /dev/null
	LD_LIBRARY_PATH=debian/libnss3/usr/lib/$(DEB_HOST_MULTIARCH):debian/libnss3/usr/lib/$(DEB_HOST_MULTIARCH)/nss debian/libnss3-tools/usr/bin/modutil -fips true -dbdir debian/tmp < /dev/null
endif

override_dh_makeshlibs:
	dh_makeshlibs -a -- -c4

ifneq (,$(DEB_HOST_MULTIARCH))
override_dh_gencontrol:
	dh_gencontrol -- -Vmisc:Multi-Arch=same
endif

override_dh_builddeb:
	dh_builddeb -- -Zxz

%:
	dh $@

## nss 3.61

=== nss/lib/freebl/Makefile ===
--- 
+++ 
@@ -293,9 +293,12 @@
 endif
 ifeq ($(CPU_ARCH),ppc)
     EXTRA_SRCS += gcm-ppc.c
-    ASFILES += sha512-p8.s
 ifdef USE_64
     DEFINES += -DNSS_NO_INIT_SUPPORT
+    PPC_ABI := $(shell $(CC) -dM -E - < /dev/null | awk '$$2 == "_CALL_ELF" {print $$3}')
+    ifeq ($(PPC_ABI),2)
+        ASFILES += sha512-p8.s
+    endif
 endif # USE_64
 endif # ppc
 endif # Linux
@@ -345,5 +348,3 @@
 # The blapi functions are defined not only in the freebl shared
 # libraries but also in the shared libraries linked with loader.c
 # (libsoftokn3.so and libssl3.so).  We need to use GNU ld's
-# -Bsymbolic option or the equivalent option for other linkers
-# to bind the blapi function references in FREEBLVector vector

=== debian/changelog ===
nss (2:3.61-1+deb11u4) bullseye-security; urgency=medium

  * Non-maintainer upload by the Security Team.
  * d/tests: add smoke-test autopkgtest
  * d/tests: add certutil-basic-workflow autopkgtest
  * debian: add salsa-ci.yaml file
  * nss: add patch for CVE-2024-0743
  * nss: add patch for CVE-2024-6602
  * nss: add patch for CVE-2024-6609
  * nss: disable build of GTEST

 -- Arturo Borrero Gonzalez <arturo@debian.org>  Sat, 12 Oct 2024 13:25:50 +0200

nss (2:3.61-1+deb11u3) bullseye-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Improve handling of unknown PKCS#12 safe bag types (CVE-2023-0767)

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 15 Feb 2023 21:31:28 +0100

nss (2:3.61-1+deb11u2) bullseye-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Check for missing signedData field (CVE-2022-22747)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 23 Jan 2022 08:55:45 +0100

nss (2:3.61-1+deb11u1) bullseye-security; urgency=high

  * Non-maintainer upload by the Security Team.
  * Ensure DER encoded signatures are within size limits (CVE-2021-43527)

 -- Salvatore Bonaccorso <carnil@debian.org>  Wed, 01 Dec 2021 19:22:13 +0100

nss (2:3.61-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Hommey <glandium@goemon>  Mon, 08 Feb 2021 06:10:24 +0900

=== debian/rules ===
--- 
+++ 
@@ -115,6 +115,7 @@
 		DSO_LDOPTS='-shared $$(LDFLAGS)' \
 		NSS_USE_SYSTEM_SQLITE=1 \
 		NSS_ENABLE_ECC=1 \
+		NSS_DISABLE_GTESTS=1 \
 		CHECKLOC= \
 		$(TOOLCHAIN)
 
@@ -169,8 +170,7 @@
 endif
 
 override_dh_strip:
-	dh_strip --no-automatic-dbgsym
-#	dh_strip --dbgsym-migration='libnss3-dbg (<< 2:3.37-1~)'
+	dh_strip --dbgsym-migration='libnss3-dbg (<< 2:3.37-1~)'
 	$(foreach lib,libsoftokn3.so libfreebl3.so libfreeblpriv3.so libnssdbm3.so, \
 		$(call cmd,umask 022; $(SHLIBSIGN) -v -i debian/libnss3/usr/lib/$(DEB_HOST_MULTIARCH)/nss/$(lib)))

=== debian/tests/control ===
Tests: smoke-test
Depends: @

Tests: certutil-basic-workflow
Depends: @
Restrictions: allow-stderr

## nss 3.63

=== debian/changelog ===
nss (2:3.63-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/libnss3.links: make freebl3 available as library (LP #1744328)
    - d/control: add dh-exec to Build-Depends
    - d/rules: make mkdir tolerate debian/tmp existing (due to dh-exec)
    - Disable reading fips_enabled flag in FIPS mode. libnss is
      not a FIPS certified library. (LP #1837734)
    - Set TLSv1.2 as minimum TLS version. LP #1856428
    - Symlink chk files to fix self-verification in FIPS mode (LP #1885562)
    - debian/patches/fix-ftbfs-s390x.patch: fix some uninitialized
      variable warnings and format overflows for s390x.
    - debian/patches/fix-ftbfs-glibc-invalid-oob-error.patch: Disable
      non-null error checking on call to getcwd since this results in an
      erroneous warning that causes the build to fail otherwise

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 29 Mar 2021 20:54:57 +0200

nss (2:3.63-1) unstable; urgency=medium

  * New upstream release. Fixes: #984657.

 -- Mike Hommey <glandium@debian.org>  Wed, 24 Mar 2021 12:51:23 +0900

nss (2:3.61-1ubuntu2) hirsute; urgency=medium

  * No change rebuild with fixed ownership.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 16 Feb 2021 15:18:55 +0000

nss (2:3.61-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/libnss3.links: make freebl3 available as library (LP #1744328)
    - d/control: add dh-exec to Build-Depends
    - d/rules: make mkdir tolerate debian/tmp existing (due to dh-exec)
    - Disable reading fips_enabled flag in FIPS mode. libnss is
      not a FIPS certified library. (LP #1837734)
    - Set TLSv1.2 as minimum TLS version. LP #1856428
    - Symlink chk files to fix self-verification in FIPS mode (LP #1885562)
    - debian/patches/fix-ftbfs-s390x.patch: fix some uninitialized
      variable warnings and format overflows for s390x.
    - debian/patches/fix-ftbfs-glibc-invalid-oob-error.patch: Disable
      non-null error checking on call to getcwd since this results in an
      erroneous warning that causes the build to fail otherwise

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 09 Feb 2021 14:26:16 +0100

nss (2:3.60-1ubuntu1) hirsute; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/libnss3.links: make freebl3 available as library (LP #1744328)
    - d/control: add dh-exec to Build-Depends
    - d/rules: make mkdir tolerate debian/tmp existing (due to dh-exec)
    - Disable reading fips_enabled flag in FIPS mode. libnss is
      not a FIPS certified library. (LP #1837734)
    - Set TLSv1.2 as minimum TLS version. LP #1856428
    - Symlink chk files to fix self-verification in FIPS mode (LP #1885562)
    - debian/patches/fix-ftbfs-s390x.patch: fix some uninitialized
      variable warnings and format overflows for s390x.
    - debian/patches/fix-ftbfs-glibc-invalid-oob-error.patch: Disable
      non-null error checking on call to getcwd since this results in an
      erroneous warning that causes the build to fail otherwise

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 21 Dec 2020 09:21:07 +0100

nss (2:3.59-1ubuntu1) hirsute; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/libnss3.links: make freebl3 available as library (LP #1744328)
    - d/control: add dh-exec to Build-Depends
    - d/rules: make mkdir tolerate debian/tmp existing (due to dh-exec)
    - Disable reading fips_enabled flag in FIPS mode. libnss is
      not a FIPS certified library. (LP #1837734)
    - Set TLSv1.2 as minimum TLS version. LP #1856428
    - Symlink chk files to fix self-verification in FIPS mode (LP #1885562)
    - debian/patches/fix-ftbfs-s390x.patch: fix some uninitialized
      variable warnings and format overflows for s390x.
    - debian/patches/fix-ftbfs-glibc-invalid-oob-error.patch: Disable
      non-null error checking on call to getcwd since this results in an
      erroneous warning that causes the build to fail otherwise

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Nov 2020 13:39:04 +0100

nss (2:3.55-1ubuntu4) hirsute; urgency=medium

  * Chmod +x d/libnss3.links, otherwise dh-exec can't do the right job in
    substituting DEB_HOST_MULTIARCH

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 28 Nov 2020 13:34:53 +0100

## nss 3.68

=== debian/changelog ===
nss (2:3.68-1ubuntu1) impish; urgency=medium

  * Merge with Debian unstable. Remaining changes:
    - d/libnss3.links: Make freebl3 available as library. (LP #1744328)
    - d/control: Add dh-exec to Build-Depends.
    - d/rules: Make mkdir tolerate debian/tmp existing (due to dh-exec).
    - d/p/disable_fips_enabled_read.patch: Disable reading fips_enabled flag
      in FIPS mode as libnss is not a FIPS certified library. (LP #1837734)
    - d/p/set-tls1.2-as-minimum.patch: Set TLSv1.2 as minimum TLS version.
      (LP #1856428)
    - d/libnss3.links.in: Symlink chk files to fix self-verification in
      FIPS mode. (LP #1885562)
    - d/p/fix-ftbfs-s390x.patch: Fix some uninitialized variable warnings
      and format overflows for s390x.
    - d/p/fix-ftbfs-glibc-invalid-oob-error.patch: Disable non-null error
      checking on call to getcwd since this results in an erroneous warning
      that causes the build to fail otherwise.
  * New changes:
    - d/rules: Disable LTO on s390x for now. (LP #1931104)

 -- Paride Legovini <paride@ubuntu.com>  Wed, 28 Jul 2021 15:27:12 +0200

nss (2:3.68-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Hommey <glandium@debian.org>  Mon, 19 Jul 2021 06:23:39 +0900

nss (2:3.67-2) unstable; urgency=medium

  * nss/lib/ssl/sslinfo.c, nss/lib/ssl/sslt.h, nss/cmd/selfserv/selfserv.c,
    nss/cmd/strsclnt/strsclnt.c, nss/cmd/tstclnt/tstclnt.c: Make
    SSL_GetChannelInfo ABI compatible with older versions by default. Nothing
    else than NSS itself currently uses the new field. Closes: #990059.

 -- Mike Hommey <glandium@debian.org>  Mon, 05 Jul 2021 07:58:02 +0900

nss (2:3.67-1) unstable; urgency=medium

  * New upstream release. Fixes: #989410.

 -- Mike Hommey <glandium@debian.org>  Fri, 11 Jun 2021 09:58:51 +0900

nss (2:3.66-1) unstable; urgency=medium

  * New upstream release.
  * debian/libnss3.symbols: Add NSS_3.65/NSS_3.66 symbol versions.

 -- Mike Hommey <glandium@debian.org>  Wed, 02 Jun 2021 05:53:44 +0900

## nss 3.68.2

=== nss/Makefile ===
#! gmake
#
# This Source Code Form is subject to the terms of the Mozilla Public
# License, v. 2.0. If a copy of the MPL was not distributed with this
# file, You can obtain one at http://mozilla.org/MPL/2.0/.

#######################################################################
# (1) Include initial platform-independent assignments (MANDATORY).   #
#######################################################################

include manifest.mn

#######################################################################
# (2) Include "global" configuration information. (OPTIONAL)          #
#######################################################################

include $(CORE_DEPTH)/coreconf/config.mk

#######################################################################
# (3) Include "component" configuration information. (OPTIONAL)       #
#######################################################################



#######################################################################
# (4) Include "local" platform-dependent assignments (OPTIONAL).      #
#######################################################################

ifdef NSS_DISABLE_GTESTS
DIRS := $(filter-out gtests,$(DIRS))
DIRS := $(filter-out cpputil,$(DIRS))
endif

#######################################################################
# (5) Execute "global" rules. (OPTIONAL)                              #
#######################################################################

include $(CORE_DEPTH)/coreconf/rules.mk

#######################################################################
# (6) Execute "component" rules. (OPTIONAL)                           #
#######################################################################



#######################################################################
# (7) Execute "local" rules. (OPTIONAL).                              #
#######################################################################

nss_build_all:
	$(MAKE) build_nspr
	$(MAKE) all
	$(MAKE) latest

nss_clean_all:
	$(MAKE) clobber_nspr
	$(MAKE) clobber

NSPR_CONFIG_STATUS = $(CORE_DEPTH)/../nspr/$(OBJDIR_NAME)/config.status
NSPR_CONFIGURE = $(CORE_DEPTH)/../nspr/configure

#
# Translate coreconf build options to NSPR configure options.
#

ifeq ($(OS_TARGET),Android)
NSPR_CONFIGURE_OPTS += --with-android-ndk=$(ANDROID_NDK) \
                       --target=$(ANDROID_PREFIX) \
                       --with-android-version=$(OS_TARGET_RELEASE) \
                       --with-android-toolchain=$(ANDROID_TOOLCHAIN) \
                       --with-android-platform=$(ANDROID_SYSROOT)
endif
ifdef BUILD_OPT
NSPR_CONFIGURE_OPTS += --disable-debug --enable-optimize
endif
ifdef USE_X32
NSPR_CONFIGURE_OPTS += --enable-x32
endif
ifdef USE_64
NSPR_CONFIGURE_OPTS += --enable-64bit
endif
ifeq ($(OS_TARGET),WIN95)
NSPR_CONFIGURE_OPTS += --enable-win32-target=WIN95
endif
ifdef USE_DEBUG_RTL
NSPR_CONFIGURE_OPTS += --enable-debug-rtl
endif
ifdef USE_STATIC_RTL
NSPR_CONFIGURE_OPTS += --enable-static-rtl
endif
ifdef NS_USE_GCC
NSPR_CONFIGURE_ENV = CC=gcc CXX=g++
endif
# Make sure to remove -arch arguments. NSPR can't handle that.
remove_arch = $(filter-out __REMOVEME%,$(subst $(NULL) -arch , __REMOVEME,$(1)))
ifdef CC
NSPR_CONFIGURE_ENV = CC="$(call remove_arch,$(CC))"
endif
ifdef CCC
NSPR_CONFIGURE_ENV += CXX="$(call remove_arch,$(CCC))"
endif

#
# Some pwd commands on Windows (for example, the pwd
# command in Cygwin) return a pathname that begins
# with a (forward) slash.  When such a pathname is
# passed to Windows build tools (for example, cl), it
# is mistaken as a command-line option.  If that is the case,
# we use a relative pathname as NSPR's prefix on Windows.
#

USEABSPATH="YES"
ifeq (,$(filter-out WIN%,$(OS_TARGET)))
ifeq (,$(findstring :,$(shell pwd)))
USEABSPATH="NO"
endif
endif
ifeq ($(USEABSPATH),"YES")
NSPR_PREFIX = $(shell pwd)/../dist/$(OBJDIR_NAME)
else
NSPR_PREFIX = $$(topsrcdir)/../dist/$(OBJDIR_NAME)
endif

ifndef NSS_GYP_PREFIX
$(NSPR_CONFIG_STATUS): $(NSPR_CONFIGURE)
	mkdir -p $(CORE_DEPTH)/../nspr/$(OBJDIR_NAME)
	cd $(CORE_DEPTH)/../nspr/$(OBJDIR_NAME) ; \
	$(NSPR_CONFIGURE_ENV) sh ../configure \
	$(NSPR_CONFIGURE_OPTS) \
	--with-dist-prefix='$(NSPR_PREFIX)' \
	--with-dist-includedir='$(NSPR_PREFIX)/include'
else
$(NSPR_CONFIG_STATUS): $(NSPR_CONFIGURE)
	mkdir -p $(CORE_DEPTH)/../nspr/$(OBJDIR_NAME)
	cd $(CORE_DEPTH)/../nspr/$(OBJDIR_NAME) ; \
	$(NSPR_CONFIGURE_ENV) sh ../configure \
	$(NSPR_CONFIGURE_OPTS) \
	--prefix='$(NSS_GYP_PREFIX)'
endif

build_nspr: $(NSPR_CONFIG_STATUS)
	$(MAKE) -C $(CORE_DEPTH)/../nspr/$(OBJDIR_NAME)
	$(MAKE) -C $(CORE_DEPTH)/../nspr/$(OBJDIR_NAME)/pr/tests

install_nspr: build_nspr
	$(MAKE) -C $(CORE_DEPTH)/../nspr/$(OBJDIR_NAME) install

clobber_nspr: $(NSPR_CONFIG_STATUS)
	$(MAKE) -C $(CORE_DEPTH)/../nspr/$(OBJDIR_NAME) clobber

build_docs:
	$(MAKE) -C $(CORE_DEPTH)/doc

clean_docs:
	$(MAKE) -C $(CORE_DEPTH)/doc clean

nss_RelEng_bld: import all

package:
	$(MAKE) -C pkg publish

latest:
	echo $(OBJDIR_NAME) > $(CORE_DEPTH)/../dist/latest

=== debian/changelog ===
nss (2:3.68.2-0ubuntu1) jammy; urgency=medium

  * New upstream release. (LP: #1959126)
  * d/p/CVE-2021-43527.patch: drop patch applied upstream.
    [ Fixed in 3.68.1 ]

 -- Athos Ribeiro <athos.ribeiro@canonical.com>  Mon, 21 Feb 2022 14:55:42 -0300

nss (2:3.68-1ubuntu2) jammy; urgency=medium

  * SECURITY UPDATE: heap overflow when verifying DSA/RSA-PSS DER-encoded
    signatures
    - debian/patches/CVE-2021-43527.patch: check signature lengths in
      nss/lib/cryptohi/secvfy.c.
    - CVE-2021-43527

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 29 Nov 2021 07:12:54 -0500

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: nss
 Section: libs
 Priority: optional
-Maintainer: SwampRabbit <swamprabbit@mxlinux.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
 XSBC-Original-Maintainer: Maintainers of Mozilla-related packages <team+pkg-mozilla@tracker.debian.org>
 Uploaders: Mike Hommey <glandium@debian.org>
 Build-Depends: debhelper (>= 9.20160403),
+ dh-exec,
  dpkg-dev (>= 1.17.14),
  libnspr4-dev (>= 2:4.24),
  zlib1g-dev,

=== debian/rules ===
--- 
+++ 
@@ -11,6 +11,12 @@
 $(call lazy,CFLAGS,$$(shell dpkg-buildflags --get CFLAGS))
 $(call lazy,CPPFLAGS,$$(shell dpkg-buildflags --get CPPFLAGS))
 $(call lazy,LDFLAGS,$$(shell dpkg-buildflags --get LDFLAGS))
+
+# Disable the LTO optimizations on s390x for now.
+# See LP: #1931104 and https://bugzilla.mozilla.org/show_bug.cgi?id=1721995.
+ifeq ($(DEB_BUILD_ARCH),s390x)
+export DEB_BUILD_MAINT_OPTIONS = optimize=-lto
+endif
 
 PREPROCESS_FILES := $(wildcard debian/*.in)
 
@@ -115,7 +121,6 @@
 		DSO_LDOPTS='-shared $$(LDFLAGS)' \
 		NSS_USE_SYSTEM_SQLITE=1 \
 		NSS_ENABLE_ECC=1 \
-		NSS_DISABLE_GTESTS=1 \
 		CHECKLOC= \
 		$(TOOLCHAIN)
 
@@ -176,7 +181,7 @@
 
 ifeq ($(DEB_HOST_ARCH),$(DEB_BUILD_ARCH))
 	# Check FIPS mode correctly works
-	mkdir debian/tmp
+	mkdir -p debian/tmp
 	LD_LIBRARY_PATH=debian/libnss3/usr/lib/$(DEB_HOST_MULTIARCH):debian/libnss3/usr/lib/$(DEB_HOST_MULTIARCH)/nss debian/libnss3-tools/usr/bin/modutil -create -dbdir debian/tmp < /dev/null
 	LD_LIBRARY_PATH=debian/libnss3/usr/lib/$(DEB_HOST_MULTIARCH):debian/libnss3/usr/lib/$(DEB_HOST_MULTIARCH)/nss debian/libnss3-tools/usr/bin/modutil -fips true -dbdir debian/tmp < /dev/null
 endif

## nss 3.77

=== debian/changelog ===
nss (2:3.77-1) unstable; urgency=medium

  * New upstream release.
  * debian/libnss3.symbols: Add NSS_3.77 symbol version.

 -- Mike Hommey <glandium@debian.org>  Wed, 06 Apr 2022 09:18:22 +0900

nss (2:3.75-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Hommey <glandium@debian.org>  Wed, 09 Feb 2022 08:46:51 +0900

nss (2:3.73.1-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Hommey <glandium@debian.org>  Fri, 17 Dec 2021 06:16:55 +0900

nss (2:3.73-1) unstable; urgency=medium

  * New upstream release.
  * Fixes MFSA-2021-51, aka CVE-2021-43527: Memory corruption via DER-encoded
    DSA and RSA-PSS signatures.

 -- Mike Hommey <glandium@debian.org>  Thu, 02 Dec 2021 06:04:31 +0900

nss (2:3.72-2) unstable; urgency=medium

  * debian/control: libnss3-dev breaks libxmlsec1-dev (<< 1.2.33-1).
    Closes: #998733.

 -- Mike Hommey <glandium@debian.org>  Fri, 12 Nov 2021 06:21:05 +0900

nss (2:3.72-1) unstable; urgency=medium

  * New upstream release.
  * debian/libnss3.symbols, nss/lib/ssl/sslinfo.c, nss/lib/ssl/sslt.h,
    nss/cmd/selfserv/selfserv.c, nss/cmd/strsclnt/strsclnt.c,
    nss/cmd/tstclnt/tstclnt.c: Bump dependency version for SSL_GetChannelInfo
    symbol and remove the previous workaround. Closes: #990058.
  * debian/libnss3.lintian-overrides.in, debian/rules,
    nss/cmd/shlibsign/shlibsign.c, nss/lib/pk11wrap/pk11load.c,
    nss/lib/util/secload.c, nss/cmd/shlibsign/Makefile,
    nss/cmd/shlibsign/manifest.mn: Stop putting freebl, softokn, etc. in a
    subdirectory. It's a deviation from upstream that is causing more problems
    than it's worth keeping. Closes: #737855, #846012, #979159.
  * debian/libnss3-dev.links.in: Remove xulrunner-nss.pc.
  * debian/rules: Stop forcing xz compression.
  * debian/copyright: Add dot for continuation.
  * debian/watch: Upgrade to version 4.
  * debian/control: Upgrade Standard-Version to 4.6.0:
    - debian/rules: Build with `make -s` when DEB_BUILD_OPTIONS contains
      terse.
    - debian/control: Add Rules-Requires-Root: no.
  * debian/control: Remove conflict with libnss3-1d. The last Debian version
    with libnss3-1d was jessie, and it had a newer version anyways.
  * debian/rules: Enable all hardening options.
  * debian/libnss3-symbols: Add Build-Depends-Package in symbols file.
  * debian/*.lintian-overrides*: Remove
    copyright-refers-to-versionless-license-file lintian overrides.
  * debian/libnss3.lintian-overrides.in:
    - s/shlib-without-versioned-soname/shared-library-lacks-version/.
    - Add lacks-unversioned-link-to-shared-library overrides.
  * debian/nss-config.in, debian/rules: Ship upstream nss-config instead of
    ours. Closes: #737855, #963136.
  * debian/rules, debian/control: Always set Multi-Arch: same.
  * debian/copyright:
    - Remove commas in `Files`.
    - Add missing license name for ifparser.
    - Add missing `Copyright`.
    - Remove copyright for mkdepend, which is not in the source tree anymore.
  * debian/upstream/metadata: Add upstream bug tracking metadata.

  [ Daniel Kahn Gillmor ]
  * debian/control: correct Homepage (old URL redirects to 404)

  [ Janitor ]
  * debian/changelog: Trim trailing whitespace.
  * debian/copyright: Use secure copyright file specification URI.
  * debian/compat, debian/control:
    - Bump debhelper from deprecated 9 to 13.
    - Set debhelper-compat version in Build-Depends.
  * debian/upstream/metadata: Set upstream metadata fields: Repository.
  * debian/rules: Drop transition for old debug package migration.

 -- Mike Hommey <glandium@debian.org>  Tue, 02 Nov 2021 06:57:06 +0900

nss (2:3.70-1) unstable; urgency=medium

  * New upstream release.

 -- Mike Hommey <glandium@debian.org>  Wed, 08 Sep 2021 08:31:23 +0900

=== debian/control ===
--- 
+++ 
@@ -1,18 +1,17 @@
 Source: nss
 Section: libs
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Maintainers of Mozilla-related packages <team+pkg-mozilla@tracker.debian.org>
+Maintainer: Maintainers of Mozilla-related packages <team+pkg-mozilla@tracker.debian.org>
 Uploaders: Mike Hommey <glandium@debian.org>
-Build-Depends: debhelper (>= 9.20160403),
- dh-exec,
+Build-Depends: debhelper-compat (= 13),
  dpkg-dev (>= 1.17.14),
  libnspr4-dev (>= 2:4.24),
  zlib1g-dev,
  libsqlite3-dev (>= 3.3.9),
  libnss3-tools:native (>= 2:3.19-1-1~) <cross>
-Standards-Version: 4.1.4
-Homepage: http://www.mozilla.org/projects/security/pki/nss/
+Standards-Version: 4.6.0
+Homepage: https://developer.mozilla.org/en-US/docs/Mozilla/Projects/NSS
+Rules-Requires-Root: no
 Vcs-Git: https://salsa.debian.org/mozilla-team/nss.git
 Vcs-Browser: https://salsa.debian.org/mozilla-team/nss
 
@@ -21,8 +20,7 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${shlibs:Depends},
  ${misc:Depends}
-Conflicts: libnss3-1d (<< 2:3.13.4-2)
-Multi-Arch: ${misc:Multi-Arch}
+Multi-Arch: same
 Description: Network Security Service libraries
  This is a set of libraries designed to support cross-platform development
  of security-enabled client and server applications. It can support SSLv2
@@ -54,7 +52,8 @@
 Depends: ${misc:Depends},
  libnss3 (= ${binary:Version}),
  libnspr4-dev (>= 4.6.6-1)
-Multi-Arch: ${misc:Multi-Arch}
+Breaks: libxmlsec1-dev (<< 1.2.33-1~)
+Multi-Arch: same
 Description: Development files for the Network Security Service libraries
  This is a set of libraries designed to support cross-platform development
  of security-enabled client and server applications. It can support SSLv2
